package ru.ulstu.extractor.rule.service;

import org.springframework.stereotype.Service;
import ru.ulstu.extractor.rule.model.AddRuleForm;
import ru.ulstu.extractor.rule.model.Rule;
import ru.ulstu.extractor.rule.repository.RuleRepository;
import ru.ulstu.extractor.ts.model.TimeSeriesType;
import ru.ulstu.extractor.ts.service.TimeSeriesService;

import java.util.List;

@Service
public class RuleService {
    private final RuleRepository ruleRepository;
    private final TimeSeriesService timeSeriesService;
    private final AntecedentValueService antecedentValueService;

    public RuleService(RuleRepository ruleRepository,
                       TimeSeriesService timeSeriesService,
                       AntecedentValueService antecedentValueService) {
        this.ruleRepository = ruleRepository;
        this.timeSeriesService = timeSeriesService;
        this.antecedentValueService = antecedentValueService;
    }

    public List<Rule> getList() {
        return ruleRepository.findAll();
    }

    public void saveRule(AddRuleForm addRuleForm) {
        ruleRepository.save(new Rule(antecedentValueService.getById(addRuleForm.getFirstAntecedentValueId()),
                TimeSeriesType.valueOf(addRuleForm.getFirstAntecedentId()),
                antecedentValueService.getById(addRuleForm.getSecondAntecedentValueId()),
                TimeSeriesType.valueOf(addRuleForm.getSecondAntecedentId()),
                addRuleForm.getConsequent()));
    }
}
